﻿using FLY.Thick.Base.IService;
using FObjBase;
using FObjBase.Reflect;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FLY.Thick.Base.Client
{
    /// <summary>
    /// AD盒输入输出口描述服务
    /// </summary>
    public class FlyAdIoDefineServiceClient : FObjBase.Reflect.Reflect_SeviceClient, IFlyAdIoDefineService
    {
        protected override Type InterfaceType => typeof(IFlyAdIoDefineService);
        /// <summary>
        /// 边界查找服务 构造
        /// </summary>
        /// <param name="id"></param>
        public FlyAdIoDefineServiceClient(UInt32 id) : base(id) { }

        /// <summary>
        /// 边界查找服务 构造
        /// </summary>
        /// <param name="serviceId">服务id</param>
        /// <param name="connName">连接器</param>
        public FlyAdIoDefineServiceClient(UInt32 serviceId, string connName) : base(serviceId, connName) { }

        /// <summary>
        /// 获取输入输出口描述列表
        /// </summary>
        /// <param name="asyncDelegate"></param>
        /// <param name="asyncContext"></param>
        [Call(typeof(List<IODefine>))]
        public void GetIODefine(AsyncCBHandler asyncDelegate, object asyncContext) {

            Call(nameof(GetIODefine), null, asyncDelegate, asyncContext);
        }
    }

    /// <summary>
    /// 输入输出口描述
    /// </summary>
    public class IODefine 
    {
        /// <summary>
        /// 输入口？输出口？
        /// </summary>
        public enum IOTYPE { 

            /// <summary>
            /// 输入口
            /// </summary>
            Input,
            /// <summary>
            /// 输出口
            /// </summary>
            Output
        };

        /// <summary>
        /// 输入口？输出口？
        /// </summary>
        public IOTYPE IoType;
        /// <summary>
        /// 序号，从0开始排列
        /// </summary>
        public int Index;
        /// <summary>
        /// 功能表述
        /// </summary>
        public string Description;

    }
}
